;-------------------------------------------------------------------------;
.include "copying.inc"
.include "hv_scanline.inc"
.include "graphics.inc"
.include "oam.inc"
.include "snes.inc"
.include "snes_decompress.inc"
.include "snes_joypad.inc"
.include "snes_zvars.inc"
;-------------------------------------------------------------------------;
.import init_reg
;-------------------------------------------------------------------------;
.export DoCDSprite
;-------------------------------------------------------------------------;


;-------------------------------------------------------------------------;
BG1GFX = 01000h
BG1MAP = 00000h
OAMGFX = 04000h
;-------------------------------------------------------------------------;


;-------------------------------------------------------------------------;
SPRITE_PROP = OAM_PRI2
TABLE2 = 07h
;-------------------------------------------------------------------------;
oph = m4
opv = m4+1
spr_tile_index = m5
spr_xpos_index = m6
spr_ypos_index = m7
;-------------------------------------------------------------------------;


;/////////////////////////////////////////////////////////////////////////;
.bss
;/////////////////////////////////////////////////////////////////////////;


;-------------------------------------------------------------------------;
do_hv:
	.res	1
hv_count:
	.res	2
;-------------------------------------------------------------------------;


;/////////////////////////////////////////////////////////////////////////;
.code
;/////////////////////////////////////////////////////////////////////////;


;-------------------------------------------------------------------------;
	.a8
	.i16
;-------------------------------------------------------------------------;


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
DoCDSprite:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	rep	#10h
	sep	#20h

	sei

	jsr	ResetSprites

	lda	#BGMODE_1
	sta	REG_BGMODE
	stz	REG_BG1SC
	lda	#BG1GFX>>12
	sta	REG_BG12NBA
	lda	#TM_OBJ|TM_BG1
	sta	REG_TM

	stz	REG_BG1HOFS
	stz	REG_BG1HOFS
	lda	#0ffh
	sta	REG_BG1VOFS
	stz	REG_BG1VOFS

	DoDecompressDataVram gfx_comm_bbs_sprTiles, OAMGFX*2
	DoDecompressDataVram gfx_comm_bbsTiles, BG1GFX*2
        DoDecompressDataVram gfx_comm_bbsMap, BG1MAP*2
	DoCopyPalette gfx_comm_bbsPal, 0, 16
	DoCopyPalette OAM_PAL, 128, 128

	lda	#OBSEL_32_64|OBSEL_BASE(OAMGFX*2)
	sta	REG_OBSEL
	stz	REG_HDMAEN

	ldx	#0000h
:	lda	OAM_TILE_PROP,x
	sta	oam_table,x
	inx
	cpx	#0040h
	bne	:-

	ldx	#0003h
:	stz	oam_hitable,x
	dex
	bpl	:-

	ldy	#003ah
	sty	spr_tile_index
	;lda	$17
	;sta	spr_ypos_index
	lda	hv_count+1
	sta	spr_xpos_index
:	dea
	nop
	bpl	:-

	lda	REG_SLHV
	lda	REG_OPHCT
	and	#01h
	ina
	sta	oph
	lda	REG_OPVCT
	and	#01h
	ina
	sta	opv

	lda	#NMI_ON|NMI_JOYPAD
	sta	REG_NMITIMEN

	lda	#01h
	sta	do_hv
	sta	frame_ready

	lda	#0fh
	sta	REG_INIDISP
;-------------------------------------------------------------------------;
Loop:
;-------------------------------------------------------------------------;
	lda	REG_RDNMI
	bpl	Loop

	wai

	jsr	MoveSprites
	jsr	ForegroundBackground

	lda	joy1_down
	eor	joy1_down+1
	beq	Loop
;-------------------------------------------------------------------------;
	stz	frame_ready
	stz	do_hv
	jsr	init_reg
	rts


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
HVScanline:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	lda	do_hv
	beq	hvexit
	inc	hv_count
	lda	REG_SLHV
	eor	hv_count+1
	sta	hv_count+1
	lda	REG_OPHCT
	eor	REG_OPVCT
	adc	hv_count+1
	eor	hv_count+1
	eor	hv_count
	sta	hv_count+1
hvexit:	rts


;=========================================================================;
ResetSprites:
;=========================================================================;
	ldx	#0200h
	lda	#0e0h
:	sta	oam_table,x
	dex
	sta	oam_table,x
	dex
	stz	oam_table,x
	dex
	stz	oam_table,x
	dex
	bpl	:-

	ldx	#0020h
	lda	#%01010101
_clr:	sta	oam_hitable,x		; initialize all sprites to be off the screen
	dex
	bpl	_clr

	rts


;=========================================================================;
MoveSprites:
;=========================================================================;
	sep	#30h

	lda	spr_xpos_index
	pha
	lda	spr_ypos_index
	pha
	ldy	#40h

:	ldx	spr_xpos_index
	lda	OAM_X,x
	sta	oam_table,y

	txa
	clc
	adc	#10h
	sta	spr_xpos_index

	ldx	spr_ypos_index
	lda	OAM_Y,x
	sta	oam_table+01h,y

	txa
	clc
	adc	#10h
	sta	spr_ypos_index

	dey
	dey
	dey
	dey
	bpl	:-

	pla

	sec
	sbc	opv
	sta	spr_ypos_index

	pla

	clc
	adc	oph
	sta	spr_xpos_index
	
	rep	#10h

	rts


;=========================================================================;
ForegroundBackground:
;=========================================================================;
	sep	#30h

	lda	spr_tile_index
	pha

	ldy	#40h
;-------------------------------------------------------------------------;
:	tax
	lda	OAM_TILE_INDEX,x
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	lsr	a
	tax
	lda	OAM_TILE,x
	sta	oam_table+02h,y
	lda	oam_table+03h,y
	and	#%00001111
	ora	OAM_TILE+08h,x	;@@
	sta	oam_table+03h,y
	lda	spr_tile_index
	clc
	adc	#10h
	sta	spr_tile_index
	dey
	dey
	dey
	dey
	bpl	:-
;-------------------------------------------------------------------------;
	pla

	clc
	adc	oph
	sta	spr_tile_index

	rep	#10h

	rts


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
OAM_TILE_PROP:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	$00,$00,$0c,$70,$00,$00,$0c,$32
	.byte	$00,$00,$0c,$b4,$00,$00,$0c,$76
	.byte	$00,$00,$0c,$78,$00,$00,$0c,$ba
	.byte	$00,$00,$0c,$3c,$00,$00,$0c,$3e
	.byte	$00,$00,$0c,$b0,$00,$00,$0c,$72
	.byte	$00,$00,$0c,$f4,$00,$00,$0c,$b6
	.byte	$00,$00,$0c,$b8,$00,$00,$0c,$3a
	.byte	$00,$00,$0c,$7c,$00,$00,$0c,$be
	.byte	$00,$00,$0c,$70,$00,$00,$0c,$32
	.byte	$00,$00,$0c,$b4,$00,$00,$0c,$76
	.byte	$00,$00,$0c,$78,$00,$00,$0c,$ba
	.byte	$00,$00,$0c,$3c,$00,$00,$0c,$3e
	.byte	$00,$00,$0c,$b0,$00,$00,$0c,$72
	.byte	$00,$00,$0c,$f4,$00,$00,$0c,$b6
	.byte	$00,$00,$0c,$b8,$00,$00,$0c,$3a
	.byte	$00,$00,$0c,$7c,$00,$00,$0c,$be
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
OAM_TILE:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	$00,$04,$08,$0c,$40,$44,$48,$4c
	.byte	$00,$00,$00,$00,$30,$30,$30,$30
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
	.byte	$00,$00,$00,$00,$00,$00,$00,$00
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
OAM_X:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	$72,$74,$77,$79,$7c,$7e,$80,$83
	.byte	$85,$88,$8a,$8c,$8f,$91,$93,$96
	.byte	$98,$9a,$9c,$9e,$a1,$a3,$a5,$a7
	.byte	$a9,$ab,$ad,$af,$b1,$b2,$b4,$b6
	.byte	$b8,$b9,$bb,$bd,$be,$c0,$c1,$c3
	.byte	$c4,$c5,$c7,$c8,$c9,$ca,$cb,$cc
	.byte	$cd,$ce,$cf,$cf,$d0,$d1,$d1,$d2
	.byte	$d2,$d3,$d3,$d3,$d4,$d4,$d4,$d4
	.byte	$d4,$d4,$d4,$d4,$d3,$d3,$d3,$d2
	.byte	$d2,$d1,$d1,$d0,$cf,$cf,$ce,$cd
	.byte	$cc,$cb,$ca,$c9,$c8,$c6,$c5,$c4
	.byte	$c3,$c1,$c0,$be,$bd,$bb,$b9,$b8
	.byte	$b6,$b4,$b2,$b1,$af,$ad,$ab,$a9
	.byte	$a7,$a5,$a3,$a0,$9e,$9c,$9a,$98
	.byte	$95,$93,$91,$8e,$8c,$8a,$87,$85
	.byte	$83,$80,$7e,$7b,$79,$76,$74,$72
	.byte	$6f,$6d,$6a,$68,$65,$63,$61,$5e
	.byte	$5c,$59,$57,$55,$52,$50,$4e,$4b
	.byte	$49,$47,$45,$42,$40,$3e,$3c,$3a
	.byte	$38,$36,$34,$32,$30,$2e,$2c,$2b
	.byte	$29,$27,$25,$24,$22,$21,$1f,$1e
	.byte	$1d,$1b,$1a,$19,$18,$16,$15,$14
	.byte	$13,$13,$12,$11,$10,$0f,$0f,$0e
	.byte	$0e,$0d,$0d,$0d,$0c,$0c,$0c,$0c
	.byte	$0c,$0c,$0c,$0c,$0d,$0d,$0d,$0e
	.byte	$0e,$0f,$0f,$10,$10,$11,$12,$13
	.byte	$14,$15,$16,$17,$18,$19,$1a,$1c
	.byte	$1d,$1e,$20,$21,$23,$24,$26,$28
	.byte	$29,$2b,$2d,$2f,$31,$33,$35,$37
	.byte	$39,$3b,$3d,$3f,$41,$43,$45,$48
	.byte	$4a,$4c,$4e,$51,$53,$55,$58,$5a
	.byte	$5d,$5f,$61,$64,$66,$69,$6b,$6e
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
OAM_Y:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	$bf,$bf,$bf,$bf,$bf,$be,$be,$be
	.byte	$bd,$bd,$bc,$bc,$bb,$ba,$b9,$b9
	.byte	$b8,$b7,$b6,$b5,$b4,$b3,$b1,$b0
	.byte	$af,$ae,$ac,$ab,$a9,$a8,$a6,$a5
	.byte	$a3,$a2,$a0,$9e,$9c,$9a,$99,$97
	.byte	$95,$93,$91,$8f,$8d,$8b,$89,$86
	.byte	$84,$82,$80,$7e,$7c,$79,$77,$75
	.byte	$73,$70,$6e,$6c,$69,$67,$65,$62
	.byte	$60,$5e,$5b,$59,$57,$54,$52,$50
	.byte	$4d,$4b,$49,$47,$44,$42,$40,$3e
	.byte	$3c,$3a,$37,$35,$33,$31,$2f,$2d
	.byte	$2b,$29,$27,$26,$24,$22,$20,$1e
	.byte	$1d,$1b,$1a,$18,$17,$15,$14,$12
	.byte	$11,$10,$0f,$0d,$0c,$0b,$0a,$09
	.byte	$08,$07,$07,$06,$05,$04,$04,$03
	.byte	$03,$02,$02,$02,$01,$01,$01,$01
	.byte	$01,$01,$01,$01,$01,$02,$02,$02
	.byte	$03,$03,$04,$04,$05,$06,$07,$07
	.byte	$08,$09,$0a,$0b,$0c,$0d,$0f,$10
	.byte	$11,$12,$14,$15,$17,$18,$1a,$1b
	.byte	$1d,$1e,$20,$22,$24,$26,$27,$29
	.byte	$2b,$2d,$2f,$31,$33,$35,$37,$3a
	.byte	$3c,$3e,$40,$42,$44,$47,$49,$4b
	.byte	$4d,$50,$52,$54,$57,$59,$5b,$5e
	.byte	$60,$62,$65,$67,$69,$6c,$6e,$70
	.byte	$73,$75,$77,$79,$7c,$7e,$80,$82
	.byte	$84,$86,$89,$8b,$8d,$8f,$91,$93
	.byte	$95,$97,$99,$9a,$9c,$9e,$a0,$a2
	.byte	$a3,$a5,$a6,$a8,$a9,$ab,$ac,$ae
	.byte	$af,$b0,$b1,$b3,$b4,$b5,$b6,$b7
	.byte	$b8,$b9,$b9,$ba,$bb,$bc,$bc,$bd
	.byte	$bd,$be,$be,$be,$bf,$bf,$bf,$bf
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
OAM_TILE_INDEX:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	$80,$7d,$7a,$77,$74,$70,$6d,$6a
	.byte	$67,$64,$61,$5e,$5b,$58,$55,$52
	.byte	$50,$4d,$4a,$47,$44,$42,$3f,$3c
	.byte	$3a,$37,$35,$32,$30,$2d,$2b,$29
	.byte	$26,$24,$22,$20,$1e,$1c,$1a,$18
	.byte	$17,$15,$13,$12,$10,$0f,$0d,$0c
	.byte	$0b,$0a,$09,$08,$07,$06,$05,$04
	.byte	$04,$03,$02,$02,$02,$01,$01,$01
	.byte	$01,$01,$01,$01,$02,$02,$02,$03
	.byte	$03,$04,$05,$05,$06,$07,$08,$09
	.byte	$0a,$0c,$0d,$0e,$10,$11,$13,$14
	.byte	$16,$18,$1a,$1b,$1d,$1f,$21,$23
	.byte	$26,$28,$2a,$2c,$2f,$31,$34,$36
	.byte	$39,$3b,$3e,$41,$43,$46,$49,$4c
	.byte	$4f,$51,$54,$57,$5a,$5d,$60,$63
	.byte	$66,$69,$6c,$6f,$72,$76,$79,$7c
	.byte	$7f,$82,$85,$88,$8b,$8e,$91,$95
	.byte	$98,$9b,$9e,$a1,$a4,$a7,$aa,$ad
	.byte	$af,$b2,$b5,$b8,$bb,$bd,$c0,$c3
	.byte	$c5,$c8,$cb,$cd,$d0,$d2,$d4,$d7
	.byte	$d9,$db,$dd,$df,$e1,$e3,$e5,$e7
	.byte	$e9,$eb,$ec,$ee,$ef,$f1,$f2,$f3
	.byte	$f5,$f6,$f7,$f8,$f9,$fa,$fb,$fc
	.byte	$fc,$fd,$fd,$fe,$fe,$ff,$ff,$ff
	.byte	$ff,$ff,$ff,$ff,$ff,$fe,$fe,$fd
	.byte	$fd,$fc,$fc,$fb,$fa,$f9,$f8,$f7
	.byte	$f6,$f5,$f4,$f2,$f1,$ef,$ee,$ec
	.byte	$eb,$e9,$e7,$e5,$e3,$e1,$df,$dd
	.byte	$db,$d9,$d7,$d4,$d2,$d0,$cd,$cb
	.byte	$c8,$c6,$c3,$c0,$be,$bb,$b8,$b5
	.byte	$b3,$b0,$ad,$aa,$a7,$a4,$a1,$9e
	.byte	$9b,$98,$95,$92,$8f,$8c,$88,$85
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
OAM_PAL:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.incbin	"../dist/sprites.pal"
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
