;-------------------------------------------------------------------------;
.include "copy256x256m7.inc"
.include "snes.inc"
.include "snes_zvars.inc"
;-------------------------------------------------------------------------;


;/////////////////////////////////////////////////////////////////////////;
.code ; by Storm/Taurus with minor modifications by Augustus Blackheart
;/////////////////////////////////////////////////////////////////////////;

	.a8
	.i16

;*************************************************************************;
; Copy M7 gfx & map 256x256 only
;       
; a = bank, assumes both graphics & map are in the same bank
; x = graphics address
; y = map address
m7_gfx_addr = memptr
m7_gfx_bank = memptr+2
m7_map_addr = m0
m7_map_bank = m1
copy_m7_map = m1+1
map_entry = m2
tile_xpos = m3
;*************************************************************************;
Copy256x256Mode7Gfx:
;-------------------------------------------------------------------------;
	sty	m7_map_addr
	stx	m7_gfx_addr
	sta	m7_gfx_bank
	sta	m7_map_bank

	lda	#80h
	sta	REG_VMAIN
	sta	copy_m7_map

	stz	tile_xpos

	ldy	#0000h
	sty	REG_VMADDL
	sty	map_entry
;-------------------------------------------------------------------------;
:	tyx
	jsr	CopyMap
	txy
	lda	[m7_gfx_addr],y
	sta	REG_VMDATAH
	iny
	cpy	#4000h
	bne	:-
;-------------------------------------------------------------------------;
	stz	REG_VMAIN

	ldx	#tile_xpos+2
:	stz	memptr,x
	dex
	bpl	:-

	rts


;=========================================================================;
CopyMap:
;=========================================================================;
	lda	copy_m7_map
	bne	cmp21h
;-------------------------------------------------------------------------;
cmp61h:	inc	tile_xpos
	lda	tile_xpos
	cmp	#61h
	bne	zvmdl
;-------------------------------------------------------------------------;
	stz	tile_xpos
	lda	#01h
	sta	copy_m7_map
;-------------------------------------------------------------------------;
cmp21h:	inc	tile_xpos
	lda	tile_xpos
	cmp	#21h
	bne	cmpmap
;-------------------------------------------------------------------------;
	stz	tile_xpos
	stz	copy_m7_map
	bra	cmp61h
;-------------------------------------------------------------------------;
zvmdl:	stz	REG_VMDATAL
	rts
;-------------------------------------------------------------------------;
cmpmap:	ldy	map_entry
	cpy	#0400h			; only a 256x256 map
	beq	zvmdl
;-------------------------------------------------------------------------;
	lda	[m7_map_addr],y		; get map data
	sta	REG_VMDATAL
	iny
	sty	map_entry
	rts
;-------------------------------------------------------------------------;
