;-------------------------------------------------------------------------;
.include "copy256x256m7.inc"
.include "m7_page_effect.inc"
.include "graphics.inc"
.include "snes.inc"
.include "snes_decompress.inc"
.include "snes_zvars.inc"
;-------------------------------------------------------------------------;


;-------------------------------------------------------------------------;
; code & gfx gin & lem, modified by Augustus Blackheart
;-------------------------------------------------------------------------;


;-------------------------------------------------------------------------;
RAM_COLDATA     = 0600h
;-------------------------------------------------------------------------;
end_flag	= m0
coldata_cmp	= m3
coldata_cmp_index = m4
coldata_index	= m5
coldata_vindex	= m6
m7a_m7d_index	= m7
;-------------------------------------------------------------------------;


;/////////////////////////////////////////////////////////////////////////;
.code
;/////////////////////////////////////////////////////////////////////////;



;-------------------------------------------------------------------------;
	.a8
	.i16
;-------------------------------------------------------------------------;


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
SetupMode7PageEffect:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	rep	#10h
	sep	#20h

	sei

	DoCopyPalette M7PAL, 0, 16

	lda	#^M7MAP
	ldx	#M7GFX
	ldy	#M7MAP
	jsr	Copy256x256Mode7Gfx

	lda	#BGMODE_7
	sta	REG_BGMODE
	stz	REG_BG1SC
	stz	REG_BG12NBA
	lda	#TM_BG1
	sta	REG_TM

	lda	#08h
	sta	REG_BG1VOFS
	stz	REG_BG1VOFS

	lda	#%11000000
	sta	REG_M7SEL

	lda	#80h
	sta	REG_M7X
	stz	REG_M7X
	sta	REG_M7Y
	stz	REG_M7Y

	jsr	ResetIndex
;---------------------------------------;---------------------------------;
CreateColData:				; save ~5775 bytes over using original list
;---------------------------------------;---------------------------------;
	ldx	#0000h			; however you could just save another 70
	ldy	#333			; bytes or so by just compressing the data
					; but isn't this fun!?!
	lda	#01h			; scanline
	xba				;
	lda	#0ffh			; coldata value
;---------------------------------------;---------------------------------;
DecVal:	xba				;
	sta	RAM_COLDATA,x		; a = scanline
	inx				;
	xba				;
	sta	RAM_COLDATA,x		; a = coldata value
	inx				;
	dey				;
	bpl	DecVal			;
;---------------------------------------;---------------------------------;
	ldy	coldata_vindex
	lda	COLDATA_VALUE,y
	inc	coldata_vindex
	ldy	coldata_cmp_index
	cpy	#COLDATA_CMP_END1-COLDATA_CMP
	bcs	Next
;-------------------------------------------------------------------------;
	jsr	GetNewCompareValue
	bra	DecVal
;-------------------------------------------------------------------------;
Next:
;---------------------------------------;---------------------------------;
	ldy	#631			;
					;
	lda	#01h			; scanline
	xba				;
	lda	#0e0h			; coldata value
;---------------------------------------;---------------------------------;
IncVal:	xba				; a = scanline
	sta	RAM_COLDATA,x		;
	inx				;
	xba				; a = coldata
	sta	RAM_COLDATA,x		;
	inx				;
	dey				;
	bpl	IncVal			;
;---------------------------------------;---------------------------------;
	ina				; increase coldata value
	ldy	coldata_cmp_index
	cpy	#COLDATA_CMP_END2-COLDATA_CMP
	bcs	EndColData
;---------------------------------------;---------------------------------;
	jsr	GetNewCompareValue
	bra	IncVal
;-------------------------------------------------------------------------;
GetNewCompareValue:
;---------------------------------------;---------------------------------;
	rep	#30h			;
					;
	pha				; preserve coldata & scanline
					;
	lda	COLDATA_CMP,y		; get new compare value
	tay				;
					;
	pla				; restore coldata & scanline
					;
	sep	#20h			;
					;
	inc	coldata_cmp_index	;
	inc	coldata_cmp_index	;
	rts
;-------------------------------------------------------------------------;
EndColData:
;-------------------------------------------------------------------------;
	lda	#0a1h
	sta	REG_CGADSUB

	lda	#02h
	sta	REG_CGSWSEL
	sta	REG_DMAP0
	sta	REG_DMAP1
	stz	REG_DMAP2

	lda	#<REG_M7A
	sta	REG_BBAD0

	lda	#<REG_M7D
	sta	REG_BBAD1

	lda	#<REG_COLDATA
	sta	REG_BBAD2

	stz	REG_A1B0
	stz	REG_A1B1
	stz	REG_A1B2

	jsr	DoMode7PageEffect

	rts


;-------------------------------------------------------------------------;
End:
;-------------------------------------------------------------------------;
	lda	#8fh
	;sta	REG_INIDISP
	sta	end_flag
;=========================================================================;
ResetIndex:
;=========================================================================;
	ldx	#LIST_M7A_M7D
	stx	m7a_m7d_index
	ldx	#RAM_COLDATA
	stx	coldata_index

	rts
;=========================================================================;
DoMode7PageEffect:
;=========================================================================;
	ldx	m7a_m7d_index
	cpx	#(LIST_M7A_M7D_END-LIST_M7A_M7D)+LIST_M7A_M7D
	bpl	End
;-------------------------------------------------------------------------;
	stx	REG_A1T0L
	stx	REG_A1T1L

	ldy	coldata_index
	sty	REG_A1T2L

	lda	#%111
	sta	REG_HDMAEN

	rep	#30h

	txa
	clc
	adc	#12
	sta	m7a_m7d_index

	tya
	clc
	adc	#8
	sta	coldata_index

	sep	#20h

	rts


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
COLDATA_CMP:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
		;ff
		;333
		;ff  fe  fd  fc  fb  fa  f9  f8
	.word	    000,001,000,001,000,001,001
		;f7  f6  f5  f4  f3  f2  f1  f0
	.word	001,001,002,002,002,004,004,013
		;ef  ee  ed  ec  eb  ea  e9  e8
	.word	019,009,007,006,006,007,007,008
		;e7  e6  e5  e4  e3  e2  e1  e0
	.word	009,014,040,019,014,015,017,079
		;e1  e2  e3  e4  e5  e4  e3  e2
	.word	017,015,014,019,033,019,014,015
		;e1  e0  e1  e2  e3  e4  e5  e4
	.word	017,079,017,015,014,019,026,010
		;e3  e2  e1  e0  e1  e2  e1  e0
	.word	006,006,006,183,013,030,023,165
		;e1  e2  e1  e0  e1  e2
	.word	023,037,023,165,023,045
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
COLDATA_CMP_END1:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
		;631
		;    e1  e2  e3  e4  e5  e6  e7	
	.word       037,050,012,009,006,006,006
		;e8  e9  ea  eb  ec  ed  ee  ef
	.word	004,005,004,005,005,005,007,014
		;f0  f1  f2  f3  f4  f5  f6  f7
	.word	014,004,004,002,002,002,001,001
		;f8  f9  fa  fb  fc  fd  fe  ff
	.word	001,001,000,001,000,001,000,331
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
COLDATA_CMP_END2:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
COLDATA_VALUE:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	    $fe,$fd,$fc,$fb,$fa,$f9,$f8
	.byte	$f7,$f6,$f5,$f4,$f3,$f2,$f1,$f0
	.byte	$ef,$ee,$ed,$ec,$eb,$ea,$e9,$e8
	.byte	$e7,$e6,$e5,$e4,$e3,$e2,$e1,$e0
	.byte	$e1,$e2,$e3,$e4,$e5,$e4,$e3,$e2
	.byte	$e1,$e0,$e1,$e2,$e3,$e4,$e5,$e4
	.byte	$e3,$e2,$e1,$e0,$e1,$e2,$e1,$e0
	.byte	$e1,$e2,$e1,$e0,$e1,$e2
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
LIST_M7A_M7D:	.incbin	"../data/list_m7a_m7b.bin"
LIST_M7A_M7D_END:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
M7MAP:	.incbin	"../mode7gfx/dist.bin"	; 1024 bytes, original 4096 bytes
M7PAL:	.incbin	"../mode7gfx/dist.pal"
M7GFX:	.incbin	"../mode7gfx/dist.pc7"	; 9024 bytes, original 15360 bytes
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
