#-------------------------------------------------------------------------
# SNES MODE 21H (HiROM) Memory Specification
#-------------------------------------------------------------------------

#*************************************************************************
MEMORY {
#*************************************************************************

#-------------------------------------------------------------------------
# HROM used for extended program code (32k)
#   ( do NOT access HROM normally! )
# CROM used for common program code (32k) (shared across banks)
#-------------------------------------------------------------------------
	HROM:	start = $C00000, size = $8000, fill = yes;
	CROM:	start = $C08000, size = $7FB0, fill = yes;
	CHEAD:	start = $FFB0, size = $50, fill = yes;
#-------------------------------------------------------------------------
# insert rom sections for program data
#-------------------------------------------------------------------------
	ROM1:	start = $c10000, size = $10000, fill = yes;
	ROM2:	start = $c20000, size = $10000, fill = yes;
	ROM3:	start = $c30000, size = $10000, fill = yes;
	ROM4:	start = $c40000, size = $10000, fill = yes;
	ROM5:	start = $c50000, size = $10000, fill = yes;
	ROM6:	start = $c60000, size = $10000, fill = yes;
	ROM7:	start = $c70000, size = $10000, fill = yes;
	ROM8:	start = $c80000, size = $10000, fill = yes;
	ROM9:	start = $c90000, size = $10000, fill = yes;
	ROMA:	start = $ca0000, size = $10000, fill = yes;
	ROMB:	start = $cb0000, size = $10000, fill = yes;
	ROMC:	start = $cc0000, size = $10000, fill = yes;
	ROMD:	start = $cd0000, size = $10000, fill = yes;
	ROME:	start = $ce0000, size = $10000, fill = yes;
	ROMF:	start = $cf0000, size = $10000, fill = yes;
#-------------------------------------------------------------------------
# 128K memory
#-------------------------------------------------------------------------
	ZPAGE:	start = $0000, size = 256;	# 8k loram
	LORAM:	start = $0100, size = 7936;	#
	HIRAM1:	start = $7E2000, size = 57344;	# 56k hiram1
	HIRAM2:	start = $7F0000, size = 65536;	# 64k hiram2
}

#*************************************************************************
SEGMENTS {
#*************************************************************************

# if you aren't using some segments you can comment them
# out to prevent linker warnings (no way to turn them off???)
#-------------------------------------------------------------------------
# standard segments
#-------------------------------------------------------------------------
	CODE:		load = CROM, type = ro;		# 32k code
	XCODE:		load = HROM, type = ro;		# 32k xcode
	HEADER:		load = CHEAD, type = ro;	# cartridge header
	ZEROPAGE:	load = ZPAGE, type = zp;	# zero page
	BSS:		load = LORAM, type = bss;	# 8k (minus zpage) bss
	
#-------------------------------------------------------------------------
# Remember to use FAR addressing or similar compensation when
# accessing data that is not mapped to bank 00H/80H
#-------------------------------------------------------------------------
	HRAM:		load = HIRAM1, type = bss;	# 56K+64K HRAM
	HRAM2:		load = HIRAM2, type = bss;	# 
	
#-------------------------------------------------------------------------
# select load and run segments for HDATA
# default: load in ROM1, run in 32k HIRAM2
#-------------------------------------------------------------------------
	HDATA:		load = ROM1, run = HIRAM2, type = rw, define = yes;
#-------------------------------------------------------------------------
	DATA00:		load = CROM, type = ro;
	SNESMOD:	load = CROM, type = ro, offset = $3000;
	DATA01:		load = CROM, type = ro;
	SOUNDBANK:	load = ROM1, type = ro;
	DATA02:		load = ROM1, type = ro;
	BRR0:		load = ROM2, type = ro;
	DATA03:		load = ROM2, type = ro;
	BRR1:		load = ROM3, type = ro;
	DATA04:		load = ROM3, type = ro;
	BRR2:		load = ROM4, type = ro;
	DATA05:		load = ROM4, type = ro;
	BRR3:		load = ROM5, type = ro;
	DATA06:		load = ROM5, type = ro;
	BRR4:		load = ROM6, type = ro;
	DATA07:		load = ROM6, type = ro;
	BRR5:		load = ROM7, type = ro;
	DATA08:		load = ROM7, type = ro;
	BRR6:		load = ROM8, type = ro;
	DATA09:		load = ROM8, type = ro;
	BRR7:		load = ROM9, type = ro;
	DATA10:		load = ROM9, type = ro;
	BRR8:		load = ROMA, type = ro;
	DATA11:		load = ROMA, type = ro;
	BRR9:		load = ROMB, type = ro;
	DATA12:		load = ROMB, type = ro;
	BRR10:		load = ROMC, type = ro;
	DATA13:		load = ROMC, type = ro;
	BRR11:		load = ROMD, type = ro;
	DATA14:		load = ROMD, type = ro;
	BRR12:		load = ROME, type = ro;
	DATA15:		load = ROME, type = ro;
	BRR13:		load = ROMF, type = ro;
	DATA16:		load = ROMF, type = ro;
}
