;-------------------------------------------------------------------------;
.include "bg_scrolltext.inc"
.include "snes.inc"
.include "snes_zvars.inc"
;-------------------------------------------------------------------------;


;/////////////////////////////////////////////////////////////////////////;
.zeropage	; 12
;/////////////////////////////////////////////////////////////////////////;


;-------------------------------------------------------------------------;
add_text:
	.res 1
text_index:
	.res 2
text_pointer:
	.res 3
reg_vmadd:
	.res 2
vm01:	.res 2
vm21:	.res 2
;-------------------------------------------------------------------------;


;/////////////////////////////////////////////////////////////////////////;
	.segment "XCODE"
;/////////////////////////////////////////////////////////////////////////;


	.a8
	.i16


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
SetupBGScrolltext:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	stx	text_pointer
	sty	reg_vmadd
	iny
	sty	vm01

	rep	#30h

	tya
	clc
	adc	#0020h
	sta	vm21

	sep	#20h

	lda	#0ffh
	sta	SCROLLTEXT_HOFS
	sta	add_text

	rts

;-------------------------------------------------------------------------;
plarts:	pla
	rts
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
BGScrolltext:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
	rep	#30h

	lda	SCROLLTEXT_HOFS
	ina
	ina
	and	#01ffh			; do not exceed 01ffh
	sta	SCROLLTEXT_HOFS

	sep	#20h

	inc	add_text
	lda	add_text
	pha				; store add_text for later
	and	#0fh			;
	bne	plarts			; not ready to print to screen
;---------------------------------------;
	lda	#VMAIN_INCH|VMAIN_INC32	;
	sta	REG_VMAIN		;
					;
	pla				; get original add_text value
	cmp	#80h			; determine which screen to write to
	bcs	Scr2			;
;---------------------------------------;
Scr1:	ldx	#0000h			; write to screen 0
	bra	:+			;
;---------------------------------------;
Scr2:	ldx	#0002h			; write to screen 1
;---------------------------------------;
:	ldy	text_index		; get current text index
	iny				; increase text index
;---------------------------------------;
:	sty	text_index		; store current index
	lda	(text_pointer),y	; load ascii code
	bne	no_reset		; end of scroll line ?
;---------------------------------------;---------------------------------;
	ldy	#0000h
	bra	:-
;-------------------------------------------------------------------------;
no_reset:
;-------------------------------------------------------------------------;
	rep	#30h

	and	#003fh
	asl
	tay

	lda	CHR_TABLE,y
	ora	#2000h
	tay				; we'll need this again...

	lda	#4			; number of columns to write
;-------------------------------------------------------------------------;
MakeColumn:
;---------------------------------------;---------------------------------;
	pha				; push number of columns to write on stack
	lda	reg_vmadd		; get vram address
	ina				; increase vram address by 1
	cmp	vm21			; check max vram address
	bne	:+			;
;---------------------------------------;
	lda	vm01			; reset vram address
;---------------------------------------;
:	sta	reg_vmadd
	clc
	adc	SCREEN,x		; add the screen we want to print to
	sta	REG_VMADD

	tya				; get char
	iny				; next char column

	sta	REG_VMDATAL		; row 1
	clc
	adc	#20h			; increase row
	sta	REG_VMDATAL		; row 2

	clc
	adc	#20h			; increase row
	sta	REG_VMDATAL		; row 3

	clc
	adc	#20h			; increase row
	sta	REG_VMDATAL		; row 4

	pla				; get number of columns to write from stack
	dea				; decrease by 1
	bne	MakeColumn

	sep	#20h

	rts


;/////////////////////////////////////////////////////////////////////////;
.code
;/////////////////////////////////////////////////////////////////////////;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
SCREEN:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.word	$0000,$0400
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
CHR_TABLE:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.word	000*4,001*4,002*4,003*4,004*4,005*4,006*4,007*4	; @-G
	.word	032*4,033*4,034*4,035*4,036*4,037*4,038*4,039*4	; H-O
	.word	064*4,065*4,066*4,067*4,068*4,069*4,070*4,071*4	; P-W
	.word	096*4,097*4,098*4,099*4,100*4,101*4,102*4,103*4	; X-:
	.word	0
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;

