#!/bin/sh
#-------------------------------------------------------------------------#
############          Cut/trimmed filed will start with t_nnn  ############
############  Final converted wav files will start with c_nnn  ############
############           Outout brr files will start with   nnn  ############
#-------------------------------------------------------------------------#
BRR_ENC=brr_encoder
BRR_OPT=-g
DIR_TO_CHECK="."
E="ERROR:"
MISSING="not found"
RATE=14000
COUNT_PRINT=0
KEEP=51136	# imperfect yet close enough value for SPEED 6, TEMPO 207 #
#KEEP=84672	#                    correct value for SPEED 6, TEMPO 125 #
MAX=69		#  probably should update to accept max from command line #
S=s
TRIM=0
TRIM_CMD=0
#-------------------------------------------------------------------------#


#---------------------------------------#---------------------------------#
dirIsWritable() {			#    is DIR_TO_CHECK writeable?   #
#---------------------------------------#---------------------------------#
	if [[ ! -w $DIR_TO_CHECK ]]; then 
	#-----------------------------------------------------------------#
		EPWD=$(pwd)
		echo "$E $PWD/$DIR_TO_CHECK is not writeable"
		exit -1
	#-----------------------------------------------------------------#
	fi
#-------------------------------------------------------------------------#
}
#-------------------------------------------------------------------------#


#---------------------------------------#---------------------------------#
if [[ ! -e "$1" ]]; then		#   print info and requirements   #
#---------------------------------------#---------------------------------#
	echo -e "Requirements:\n-------------\n\n SoX - Sound eXchange, the Swiss Army knife of audio manipulation\n $BRR_ENC - a brr encoder. Change \$BRR_ENC and \$BRR_OPT as needed\n$0 [.WAV FILE]"
#-------------------------------------------------------------------------#
else
#-------------------------------------------------------------------------#
	SOX_EXISTS=$(which sox)
	#-----------------------------------------------------------------#
	if [[ ! -e "$SOX_EXISTS" ]]; then
	#-----------------------------------------------------------------#
		echo -e "\n$E sox $MISSING"
		exit -1
	#-----------------------------------------------------------------#
	fi
	#-----------------------------------------------------------------#
	dirIsWritable
	echo "Cutting source file into $KEEP chunks"
	#-----------------------------------------------------------------#
	for i in `seq $MAX`; do
	#-----------------------------------------------------------------#
		dirIsWritable
		# set current output file name
		COUNT_PRINT=$( echo "$i" | awk '{ printf "%03d", $0 } ' )
		# update trim position
		TRIM_CMD=$( echo "$TRIM" | awk '{ print $0 "s" } ' )
		sox "$1" -c 1 "t_$COUNT_PRINT$1" trim $TRIM_CMD $KEEP$S
		let " TRIM += $KEEP "
	#-----------------------------------------------------------------#
	done
	#-----------------------------------------------------------------#
	dirIsWritable
	echo -n "Converting chunks to $RATE"; echo "K"
	#-----------------------------------------------------------------#
	for i in t_*.wav; do
	#-----------------------------------------------------------------#
		dirIsWritable
		sox "$i" -r $RATE "${i/t_/c_}"
	#-----------------------------------------------------------------#
	done
	#-----------------------------------------------------------------#
	rm -f t_*.wav
	BRR_EXISTS=$(which $BRR_ENC)
	#-----------------------------------------------------------------#
	if [[ ! -e "$BRR_EXISTS" ]]; then
	#-----------------------------------------------------------------#
		echo -e "\n$E $BRR_ENC $MISSING"
		exit -1
	#-----------------------------------------------------------------#
	fi
	#-----------------------------------------------------------------#
	DIR_TO_CHECK="../brr"
	dirIsWritable
	echo "Converting chunks to BRR"
	#-----------------------------------------------------------------#
	for i in c_*.wav; do
	#-----------------------------------------------------------------#
		dirIsWritable
		OUTFILE=${i/c_/../brr/}
		$BRR_ENC $BRR_OPT "$i" "${OUTFILE%%.wav*}.brr"
	#-----------------------------------------------------------------#
	done
	#-----------------------------------------------------------------#
	rm -f c_*.wav
#-------------------------------------------------------------------------#
fi
#-------------------------------------------------------------------------#
