;-------------------------------------------------------------------------;
.include "graphics.inc"
.include "snes.inc"
.include "snes_decompress.inc"
.include "snes_joypad.inc"
.include "snes_zvars.inc"
;-------------------------------------------------------------------------;
.import oam_hitable, oam_table
;-------------------------------------------------------------------------;
.importzp frame_ready
;-------------------------------------------------------------------------;
.export DoTaurusScroll
;-------------------------------------------------------------------------;


;-------------------------------------------------------------------------;
BG1GFX	= 5000h
BG1MAP	= 4000h
BG2GFX	= 1000h
BG2MAP	= 0000h
OAMGFX	= 6000h
;-------------------------------------------------------------------------;


;-------------------------------------------------------------------------;
RAM_STUFF	=	0400h
RAM_TEXT	=	RAM_STUFF+100h
RAM_INIDISP	=	RAM_TEXT+019h
RAM_BG1HOFS	=	RAM_INIDISP+034h
;-------------------------------------------------------------------------;


;/////////////////////////////////////////////////////////////////////////;
.zeropage
;/////////////////////////////////////////////////////////////////////////;


;-------------------------------------------------------------------------;
current_hdma_line:
	.res 2
current_sine_index_x:
	.res 2
current_sine_index_y:
	.res 2
delay1:
	.res 2
delay2:
	.res 2
exit_flag:
	.res 1
joy_enabled:
	.res 1
move_oam:
	.res 1
oam_xpos:
	.res 2
oam_xpos_index:
	.res 2
oam_ypos:
	.res 2
oam_ypos_index:
	.res 2
ram_text_index:
	.res 2
screen_wipe_end:
	.res 1
sine_index_x:
	.res 2
sine_index_y:
	.res 2
text_index:
	.res 2
;-------------------------------------------------------------------------;


;/////////////////////////////////////////////////////////////////////////;
.code
;/////////////////////////////////////////////////////////////////////////;


;-------------------------------------------------------------------------;
	.a8
	.i16
;-------------------------------------------------------------------------;


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
DoTaurusScroll:
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;

	rep	#10h
	sep	#20h

	sei
	stz	REG_NMITIMEN

	lda	#80h
	sta	REG_INIDISP
	sta	REG_VMAIN
	sta	REG_BG1HOFS
	stz	REG_BG1HOFS
	stz	REG_BG1VOFS
	stz	REG_BG1VOFS
	stz	REG_BG2HOFS

	stz	REG_BG2HOFS
	lda	#0ffh
	sta	REG_BG2VOFS
	stz	REG_BG2VOFS

	lda	#BG1MAP>>8|SC_64x32
	sta	REG_BG1SC
	stz	REG_BG2SC

	lda	#BG2GFX>>8+BG1GFX>>12
	sta	REG_BG12NBA

	lda	#BGMODE_1
	sta	REG_BGMODE

	lda	#OBSEL_16_32|OBSEL_BASE(OAMGFX*2)|OBSEL_NN_8K
	sta	REG_OBSEL

	ldx	#0100h
:	stz	RAM_STUFF,x
	dex
	bpl	:-

	stz	RAM_STUFF+03eh
	stz	RAM_STUFF+040h
	stz	exit_flag
	stz	joy_enabled
	stz	move_oam
	stz	screen_wipe_end

	ldx	#00ffh
	stx	RAM_STUFF+0adh
	ldx	#0041h			; orig 0051h
	stx	RAM_STUFF+0b3h
	stx	RAM_STUFF+0b5h
	ldx	#004eh
	stx	current_sine_index_x
	ldx	#0018h
	stx	delay2
;-------------------------------------------------------------------------;
	ldx	#BG1GFX
	stx	REG_VMADDL

	ldx	#0000h
	txy				; we'll use this later
	stx	current_hdma_line
	stx	current_sine_index_y
	stx	delay1
	stx	oam_xpos_index
	stx	oam_ypos_index
	stx	text_index
	stx	RAM_STUFF+0b1h
	stx	RAM_STUFF+030h

	lda	#00h
;-------------------------------------------------------------------------;
:	sta	REG_VMDATAL
	sta	REG_VMDATAH
	inx
	cpx	#0010h			; first 32 bytes are $00
	bne	:+
;-------------------------------------------------------------------------;
	eor	#255
;-------------------------------------------------------------------------;
:	cpx	#0020h			; second 32 bytes are $ff
	bne	:--
;-------------------------------------------------------------------------;
	ldx	#BG1MAP
	stx	REG_VMADDL
	tyx				; set x to 0
;-------------------------------------------------------------------------;
:	stz	REG_VMDATAL
	stz	REG_VMDATAH
	inx
	cpx	#0400h
	bne	:-
;-------------------------------------------------------------------------;
:	lda	#01h
	sta	REG_VMDATAL
	lda	#PALETTE1
	sta	REG_VMDATAH
	inx
	cpx	#0800h
	bne	:-
;-------------------------------------------------------------------------;
	lda	#20h
	tyx				; set x to 0
;-------------------------------------------------------------------------;
:	sta	RAM_TEXT,x
	inx
	cpx	#0019h
	bne	:-
;-------------------------------------------------------------------------;
	lda	#02h
	sta	REG_CGSWSEL
	lda	#%00110010
	sta	REG_CGADSUB
	lda	#TM_BG2|TM_BG1
	sta	REG_TM
	lda	#TM_OBJ
	sta	REG_TS
	tyx				; set x to 0
;-------------------------------------------------------------------------;
:	lda	LIST_INIDISP,x
	sta	RAM_INIDISP,x
	inx
	cpx	#LIST_INIDISP_END-LIST_INIDISP
	bne	:-
;-------------------------------------------------------------------------;
	DoDecompressDataVram gfx_logoTiles, BG2GFX*2
	DoDecompressDataVram gfx_logoMap, BG2MAP*2
	DoDecompressDataVram gfx_taurus_font_16x16Tiles, OAMGFX*2
	DoCopyPalette gfx_logoPal, 0, 16
	DoCopyPalette gfx_taurus_font_16x16Pal, 128, 16

	jsr	MoveOAM
	jsr	ManageOAM

	stz	REG_HDMAEN
	lda	#DMAP_XFER_MODE_2
	sta	REG_DMAP0
	sta	REG_DMAP1
	stz	REG_BBAD0
	ldx	#RAM_INIDISP
	stx	REG_A1T0L
	stz	REG_A1B0

	lda	#<REG_BG1HOFS
	sta	REG_BBAD1
	ldx	#RAM_BG1HOFS
	stx	REG_A1T1L
	stz	REG_A1B1

	lda	#%11
	sta	REG_HDMAEN

	lda	#NMI_ON|NMI_JOYPAD
	sta	REG_NMITIMEN

	lda	#01h
	sta	frame_ready

	cli
;-------------------------------------------------------------------------;
:	lda	REG_RDNMI
	bpl	:-

	jsr	Wavy
	jsr	MoveOAM
	jsr	ManageOAM
	jsr	Joypad
	jsr	HDMALines
	jsr	ScreenWipe
	lda	screen_wipe_end
	beq	:-
;-------------------------------------------------------------------------;
	lda	#80h
	sta	REG_INIDISP
	stz	REG_HDMAEN

	jmp	DoTaurusScroll


;=========================================================================;
HDMALines:
;=========================================================================;
	ldx	current_hdma_line
	cpx	#00e0h
	beq	exit1
;-------------------------------------------------------------------------;
	inx
	stx	current_hdma_line
	txa
	and	#7fh
	sta	RAM_INIDISP
	txa
	sec
	sbc	#7fh
	bcc	exit1
	beq	exit1
;-------------------------------------------------------------------------;
	sta	RAM_INIDISP+03h
	lda	#7fh
	sta	RAM_INIDISP
;-------------------------------------------------------------------------;
exit1:	rts


;=========================================================================;
Joypad:
;=========================================================================;
	lda	joy_enabled
	beq	exit1
;-------------------------------------------------------------------------;
	lda	joy1_down
	ora	joy2_down
	bne	:+
;-------------------------------------------------------------------------;
	lda	joy1_down+1
	ora	joy2_down+1
	beq	exit1
;-------------------------------------------------------------------------;
:	lda	#01h
	sta	exit_flag
	rts


;=========================================================================;
ManageOAM:
;=========================================================================;
	ldx	#oam_table
	stx	REG_WMADDL
	stz	REG_WMADDH

	rep	#20h

	ldx	#004eh
	lda	SINE,x
	jsr	SpriteXPOSb

	sep	#20h

	sta	REG_WMDATA

	rep	#20h

	ldx	#0000h
	lda	SINE,x
	jsr	SpriteYPOSb

	sep	#20h

	sta	REG_WMDATA
	lda	#6eh
	sta	REG_WMDATA
	lda	#OAM_PRI3
	sta	REG_WMDATA

	jsr	Scrolltext

	ldy	#0001h
;-------------------------------------------------------------------------;
:	jsr	SpriteXPOS
	sta	REG_WMDATA
	jsr	SpriteYPOS
	sta	REG_WMDATA
	jsr	SpriteTile
	sta	REG_WMDATA
	lda	#OAM_PRI3
	sta	REG_WMDATA
	iny
	cpy	#26
	bne	:-
;-------------------------------------------------------------------------;
	lda	#00h
:	sta	REG_WMDATA
	xba
	lda	#0e0h
	sta	REG_WMDATA
	lda	#80h
	sta	REG_WMDATA
	xba
	sta	REG_WMDATA
	iny
	cpy	#102+26
	bne	:-
	rts
;-------------------------------------------------------------------------;
SpriteTile:
;-------------------------------------------------------------------------;
	ldx	ram_text_index
	lda	RAM_TEXT,x
	inx
	stx	ram_text_index

	rep	#20h

	and	#003fh
	tax

	sep	#20h

	lda	ASCII_MAP,x
	rts
;-------------------------------------------------------------------------;
SpriteXPOS:
;-------------------------------------------------------------------------;
	rep	#20h

	lda	sine_index_x
	sec
	sbc	#000ch
	bpl	:+
;-------------------------------------------------------------------------;
	clc
	adc	#012ch
;-------------------------------------------------------------------------;
:	sta	sine_index_x
	ldx	sine_index_x
	lda	SINE,x
;-------------------------------------------------------------------------;
SpriteXPOSb:
;-------------------------------------------------------------------------;
	clc
	adc	oam_xpos
	bpl	:+
;-------------------------------------------------------------------------;
	lda	#0000h
	bra	:++
;-------------------------------------------------------------------------;
:	cmp	#00efh
	bmi	:+
;-------------------------------------------------------------------------;
	lda	#00efh
;-------------------------------------------------------------------------;
:	sep	#20h

	rts
;-------------------------------------------------------------------------;
SpriteYPOS:
;-------------------------------------------------------------------------;
	rep	#20h

	lda	sine_index_y
	clc
	adc	#000ch
	cmp	#012ch
	bmi	:+
;-------------------------------------------------------------------------;
	sec
	sbc	#012ch
;-------------------------------------------------------------------------;
:	sta	sine_index_y
	tax
	lda	SINE,x
;-------------------------------------------------------------------------;
SpriteYPOSb:
;-------------------------------------------------------------------------;
	clc
	adc	oam_ypos
	bpl	:+
;-------------------------------------------------------------------------;
	lda	#0000h
	bra	:++
;-------------------------------------------------------------------------;
:	cmp	#00d0h
	bmi	:+
;-------------------------------------------------------------------------;
	lda	#00d0h
;-------------------------------------------------------------------------;
:	sep	#20h

	rts


;=========================================================================;
MoveOAM:
;=========================================================================;
	ldx	oam_xpos_index
	lda	OAM_XPOS,x
	sta	oam_xpos
	lda	move_oam
	beq	:++
;-------------------------------------------------------------------------;
	inx
	cpx	#OAM_XPOS_END-OAM_XPOS
	bne	:+
;-------------------------------------------------------------------------;
	ldx	#0000h
;-------------------------------------------------------------------------;
:	stx	oam_xpos_index
:	ldx	oam_ypos_index
	lda	OAM_YPOS,x
	sta	oam_ypos
	lda	move_oam
	beq	exit2
;-------------------------------------------------------------------------;
	inx
	cpx	#OAM_YPOS_END-OAM_YPOS
	bne	:+
;-------------------------------------------------------------------------;
	ldx	#0000h
;-------------------------------------------------------------------------;
:	stx	oam_ypos_index
;-------------------------------------------------------------------------;
exit2:	rts


;=========================================================================;
ScreenWipe:
;=========================================================================;
	lda	exit_flag
	beq	exit2
;-------------------------------------------------------------------------;
	ldx	RAM_STUFF+0b1h
	cpx	#45*3
	beq	:++
;-------------------------------------------------------------------------;
	lda	RAM_BG1HOFS+01h,x
	bne	:+
;-------------------------------------------------------------------------;
	lda	#01h
	sta	RAM_BG1HOFS+01h,x
:	inx
	inx
	inx
	stx	RAM_STUFF+0b1h
:	ldx	RAM_STUFF+0b3h
	cpx	#45*3
	beq	:++
;-------------------------------------------------------------------------;
	lda	RAM_BG1HOFS+01h,x
	bne	:+
;-------------------------------------------------------------------------;
	lda	#01h
	sta	RAM_BG1HOFS+01h,x
:	inx
	inx
	inx
	stx	RAM_STUFF+0b3h
:	ldx	RAM_STUFF+0b5h
	beq	:+
;-------------------------------------------------------------------------;
	lda	RAM_BG1HOFS+01h,x
	bne	:++
;-------------------------------------------------------------------------;
	lda	#01h
	sta	RAM_BG1HOFS+01h,x
:	dex
	dex
	dex
	stx	RAM_STUFF+0b5h
:	ldx	#0000h
	txy
:	lda	RAM_BG1HOFS+01h,x
	beq	:+
;-------------------------------------------------------------------------;
	cmp	#0ffh
	beq	:+
;-------------------------------------------------------------------------;
	ina
	sta	RAM_BG1HOFS+01h,x
	ldy	#0001h
:	inx
	inx
	inx
	cpx	#45*3
	bne	:--
;-------------------------------------------------------------------------;
	cpy	#0000h
	bne	:+
;-------------------------------------------------------------------------;
	lda	#01h
	sta	screen_wipe_end
	stz	REG_TM
:	rts


;=========================================================================;
Scrolltext:
;=========================================================================;
	ldx	#0000h
	stx	ram_text_index
	ldx	current_sine_index_x
	stx	sine_index_x
	dex
	dex
	bne	:+
;-------------------------------------------------------------------------;
	ldx	#012ch
;-------------------------------------------------------------------------;
:	stx	current_sine_index_x
	ldx	current_sine_index_y
	stx	sine_index_y
	inx
	inx
	cpx	#012ch
	bne	:+
;-------------------------------------------------------------------------;
	ldx	#0000h
;-------------------------------------------------------------------------;
:	stx	current_sine_index_y
	inc	delay1
	lda	delay1
	cmp	#0006h
	beq	:+
;-------------------------------------------------------------------------;
	rts
;-------------------------------------------------------------------------;
:	stz	delay1
	ldx	delay2
	dex
	cpx	#0ffffh
	bne	:+
;-------------------------------------------------------------------------;
	ldx	#0018h
;-------------------------------------------------------------------------;
:	stx	delay2
	ldy	text_index
;-------------------------------------------------------------------------;
:	iny
	lda	SCROLLTEXT,y
	bne	:+
;-------------------------------------------------------------------------;
	;lda	#01h
	;sta	exit_flag
	lda	#20h
	ldy	#0000h
;-------------------------------------------------------------------------;
:	cmp	#'a'
	bne	:+
;-------------------------------------------------------------------------;
	sta	joy_enabled
	sta	move_oam
	bra	:--
;-------------------------------------------------------------------------;
:	sty	text_index
	sta	RAM_TEXT,x
	rts


;=========================================================================;
Wavy:
;=========================================================================;
	lda	RAM_BG1HOFS
	tay
	ldx	#0000h
;-------------------------------------------------------------------------;
:	lda	RAM_BG1HOFS+03h,x
	sta	RAM_BG1HOFS,x
	inx
	inx
	inx
	cpx	#45*3
	bne	:-
;-------------------------------------------------------------------------;
	tya
	sta	RAM_BG1HOFS,x
	rts


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
ASCII_MAP:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	;	dwn   a   b   c   d   e   f   g	; ASCII code
	.byte	$00,$02,$04,$06,$08,$0a,$0c,$0e	; 40h-47h \
	;         h   i   j   k   l   m   n   o
	.byte	$20,$22,$24,$26,$28,$2a,$2c,$2e	; 48h-4fh  |
	;	  p   q   r   s   t   u   v   w              &&3fh
	.byte	$40,$42,$44,$46,$48,$4a,$4c,$4e	; 50h-57h  |
	;	  x   y   z                 ball
	.byte	$60,$62,$64,$66,$68,$6a,$6c,$6e	; 58h-5fh /
	;	[SP]  !   "   #   $   %   &   '
	.byte	$80,$82,$84,$86,$88,$8a,$8c,$8e	; 20h-27h
	;	  (   )   *   +   ,   -   .   /
	.byte	$a0,$a2,$a4,$a6,$a8,$aa,$ac,$ae	; 28h-2fh
	;	  0   1   2   3   4   5   6   7
	.byte	$c0,$c2,$c4,$c6,$c8,$ca,$cc,$ce	; 30h-37h
	;	  8   9   :   ; lft  up rgt   ?
	.byte	$e0,$e2,$e4,$e6,$e8,$ea,$ec,$ee	; 38h-3fh
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
LIST_INIDISP:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	$01,$0f,$0f,$01,$0f,$0f,$04,$0e
	.byte	$0e,$03,$0d,$0d,$03,$0c,$0c,$03
	.byte	$0b,$0b,$02,$0a,$0a,$02,$09,$09
	.byte	$02,$08,$08,$02,$07,$07,$02,$06
	.byte	$06,$01,$05,$05,$01,$04,$04,$01
	.byte	$03,$03,$01,$02,$02,$01,$01,$01
	.byte	$01,$50,$50,$00,$01,$00,$00,$02
	.byte	$00,$00,$03,$00,$00,$04,$00,$00
	.byte	$05,$00,$00,$06,$00,$00,$07,$00
	.byte	$00,$08,$00,$00,$09,$00,$00,$0a
	.byte	$00,$00,$0b,$00,$00,$0c,$00,$00
	.byte	$0b,$00,$00,$0a,$00,$00,$09,$00
	.byte	$00,$09,$00,$00,$08,$00,$00,$07
	.byte	$00,$00,$06,$00,$00,$06,$00,$00
	.byte	$06,$00,$00,$05,$00,$00,$05,$00
	.byte	$00,$04,$00,$00,$04,$00,$00,$03
	.byte	$00,$00,$04,$00,$00,$03,$00,$00
	.byte	$02,$00,$00,$01,$00,$00,$02,$00
	.byte	$00,$03,$00,$00,$03,$00,$00,$04
	.byte	$00,$00,$04,$00,$00,$05,$00,$00
	.byte	$06,$00,$00,$07,$00,$00,$08,$00
	.byte	$00,$07,$00,$00,$06,$00,$00,$05
	.byte	$00,$00,$04,$00,$00,$03,$00,$00
	.byte	$02,$00,$00,$01,$00,$00,$00,$2d
	.byte	$29,$26,$22,$1f,$1b,$18,$15,$12
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
LIST_INIDISP_END:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
OAM_XPOS:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	$7a,$7d,$80,$83,$86,$89,$8c,$8e
	.byte	$91,$94,$97,$9a,$9d,$a0,$a3,$a6
	.byte	$a8,$ab,$ae,$b0,$b3,$b6,$b8,$bb
	.byte	$bd,$c0,$c2,$c4,$c7,$c9,$cb,$cd
	.byte	$cf,$d2,$d3,$d5,$d7,$d9,$db,$dd
	.byte	$de,$e0,$e1,$e3,$e4,$e5,$e6,$e8
	.byte	$e9,$ea,$eb,$eb,$ec,$ed,$ee,$ee
	.byte	$ef,$ef,$ef,$f0,$f0,$f0,$f0,$f0
	.byte	$f0,$f0,$ef,$ef,$ef,$ee,$ee,$ed
	.byte	$ec,$eb,$eb,$ea,$e9,$e8,$e6,$e5
	.byte	$e4,$e3,$e1,$e0,$de,$dd,$db,$d9
	.byte	$d7,$d5,$d3,$d2,$cf,$cd,$cb,$c9
	.byte	$c7,$c4,$c2,$c0,$bd,$bb,$b8,$b6
	.byte	$b3,$b0,$ae,$ab,$a8,$a6,$a3,$a0
	.byte	$9d,$9a,$97,$94,$91,$8e,$8c,$89
	.byte	$86,$83,$80,$7d,$7a,$76,$73,$70
	.byte	$6d,$6a,$67,$64,$62,$5f,$5c,$59
	.byte	$56,$53,$50,$4d,$4a,$48,$45,$42
	.byte	$40,$3d,$3a,$38,$35,$33,$30,$2e
	.byte	$2c,$29,$27,$25,$23,$21,$1e,$1d
	.byte	$1b,$19,$17,$15,$13,$12,$10,$0f
	.byte	$0d,$0c,$0b,$0a,$08,$07,$06,$05
	.byte	$05,$04,$03,$02,$02,$01,$01,$01
	.byte	$00,$00,$00,$00,$00,$00,$00,$01
	.byte	$01,$01,$02,$02,$03,$04,$05,$05
	.byte	$06,$07,$08,$0a,$0b,$0c,$0d,$0f
	.byte	$10,$12,$13,$15,$17,$19,$1b,$1d
	.byte	$1e,$21,$23,$25,$27,$29,$2c,$2e
	.byte	$30,$33,$35,$38,$3a,$3d,$40,$42
	.byte	$45,$48,$4a,$4d,$50,$53,$56,$59
	.byte	$5c,$5f,$62,$64,$67,$6a,$6d,$70
	.byte	$73,$76
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
OAM_XPOS_END:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
OAM_YPOS:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	$6a,$6d,$70,$73,$77,$7a,$7d,$80
	.byte	$83,$87,$8a,$8d,$90,$93,$96,$99
	.byte	$9c,$9e,$a1,$a4,$a6,$a9,$ac,$ae
	.byte	$b0,$b3,$b5,$b7,$b9,$bb,$bd,$bf
	.byte	$c1,$c2,$c4,$c5,$c7,$c8,$c9,$ca
	.byte	$cb,$cc,$cd,$ce,$ce,$cf,$cf,$d0
	.byte	$d0,$d0,$d0,$d0,$d0,$cf,$cf,$ce
	.byte	$ce,$cd,$cc,$cb,$ca,$c9,$c8,$c7
	.byte	$c5,$c4,$c2,$c1,$bf,$bd,$bb,$b9
	.byte	$b7,$b5,$b3,$b0,$ae,$ac,$a9,$a6
	.byte	$a4,$a1,$9e,$9c,$99,$96,$93,$90
	.byte	$8d,$8a,$87,$83,$80,$7d,$7a,$77
	.byte	$73,$70,$6d,$6a,$66,$63,$60,$5d
	.byte	$59,$56,$53,$50,$4d,$49,$46,$43
	.byte	$40,$3d,$3a,$37,$34,$32,$2f,$2c
	.byte	$2a,$27,$24,$22,$20,$1d,$1b,$19
	.byte	$17,$15,$13,$11,$0f,$0e,$0c,$0b
	.byte	$09,$08,$07,$06,$05,$04,$03,$02
	.byte	$02,$01,$01,$00,$00,$00,$00,$00
	.byte	$00,$01,$01,$02,$02,$03,$04,$05
	.byte	$06,$07,$08,$09,$0b,$0c,$0e,$0f
	.byte	$11,$13,$15,$17,$19,$1b,$1d,$20
	.byte	$22,$24,$27,$2a,$2c,$2f,$32,$34
	.byte	$37,$3a,$3d,$40,$43,$46,$49,$4d
	.byte	$50,$53,$56,$59,$5d,$60,$63,$66
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
OAM_YPOS_END:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
SCROLLTEXT:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.byte	"                              T "
	.byte	"E L L   M E   S O M E T H I N G "
	.byte	"  I   D O N ' T   K N O W   . . "
	.byte	".   S H O W   M E   S O M E T H "
	.byte	"I N G   I   C A N   U S E   . . "
	.byte	".   P U S H   T H E   B U T T O "
	.byte	"N   . . .   C O N N E C T   T H "
	.byte	"E   G A D G E T   . . .   G O O "
	.byte	"O O O O O O O Oa FUCK YOU SUCKEE" ; 61h (lowercase a) changes mode
	.byte	"EER!!! WHO TOLD YA TO POLLUTE TH"
	.byte	"IS PLANET WITH YAR FUCKIN BODY? "
	.byte	"FUCK OFF! SHUT UP! MAKE YOUR MEA"
	.byte	"NINGLESS LIFE AN END! NOOOOOOW!!"
	.byte	"!  YA'R STILL ALIVE! SUCKER! PIS"
	.byte	"S OFF! YA'R ONLY A PIECE'O SHIT!"
	.byte	" WHEN YOU'RE DEAD, NOONE WILL RE"
	.byte	"MEMBER YOU! YA'LL BE FORGOTTEN F"
	.byte	"OR ALL TIMES! YAR SOUL WILL BE S"
	.byte	"MASHED BY EVIL POWERS AND YOU WI"
	.byte	"LL BE TORTURED BY THE FATE FOR A"
	.byte	"LL TIME! ALWAYS REMEMBER MY WORD"
	.byte	"S...  FUCK YOU!                 "
	.byte	"                                "
	.byte	"                                "
	.byte	"           ",$0
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;


;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
SINE:
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
	.word	$0001,$0004,$0006,$0008,$000a,$000d,$000f,$0011
	.word	$0014,$0016,$0018,$001a,$001c,$001e,$0020,$0022
	.word	$0024,$0025,$0027,$0029,$002a,$002c,$002d,$002f
	.word	$0030,$0031,$0032,$0033,$0034,$0035,$0036,$0036
	.word	$0037,$0037,$0038,$0038,$0038,$0038,$0038,$0038
	.word	$0038,$0037,$0037,$0036,$0036,$0035,$0034,$0033
	.word	$0032,$0031,$0030,$002f,$002d,$002c,$002a,$0029
	.word	$0027,$0025,$0024,$0022,$0020,$001e,$001c,$001a
	.word	$0018,$0016,$0014,$0011,$000f,$000d,$000a,$0008
	.word	$0006,$0004,$0001,$ffff,$fffc,$fffa,$fff8,$fff6
	.word	$fff3,$fff1,$ffef,$ffec,$ffea,$ffe8,$ffe6,$ffe4
	.word	$ffe2,$ffe0,$ffde,$ffdc,$ffdb,$ffd9,$ffd7,$ffd6
	.word	$ffd4,$ffd3,$ffd1,$ffd0,$ffcf,$ffce,$ffcd,$ffcc
	.word	$ffcb,$ffca,$ffca,$ffc9,$ffc9,$ffc8,$ffc8,$ffc8
	.word	$ffc8,$ffc8,$ffc8,$ffc8,$ffc9,$ffc9,$ffca,$ffca
	.word	$ffcb,$ffcc,$ffcd,$ffce,$ffcf,$ffd0,$ffd1,$ffd3
	.word	$ffd4,$ffd6,$ffd7,$ffd9,$ffdb,$ffdc,$ffde,$ffe0
	.word	$ffe2,$ffe4,$ffe6,$ffe8,$ffea,$ffec,$ffef,$fff1
	.word	$fff3,$fff6,$fff8,$fffa,$fffc,$ffff
;=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=;
