.ifndef __SNES_INIT__
__SNES_INIT__ = 1

.global _start

;*************************************************************************;
;* ClearPalette					* Clobbers   X
;*
;* Clears all palettes
;*************************************************************************;
.global ClearPalette, clear_palette


;*************************************************************************;
;* a = bank					* Clobbers A,X,Y
;* x = address
;* y = length
;*************************************************************************;
.global ClearRAM


;*************************************************************************;
;* ClearWorkRAM7E				* Clobbers A,X,Y
;*
;* Clears 7e2000h - 7effffh
;* clears carry
;*************************************************************************;
.global ClearWorkRAM7E


;*************************************************************************;
;* ClearWorkRAM7F				* Clobbers A,X,Y
;*
;* Clears 7f0000h - 7fffffh
;* clears carry
;*************************************************************************;
.global ClearWorkRAM7F


;*************************************************************************;
;* Clear all VRAM				* Clobbers A,X,Y
;*						* Does not preserve m0
;*************************************************************************;
.global ClearVRAM, clear_vram


;*************************************************************************;
;* Initilize OAM				* Clobbers A,X
;*************************************************************************;
.global InitOAM, init_oam


;*************************************************************************;
;* Initilize registers				* Clobbers A,X
;*************************************************************************;
.global InitReg, init_reg


;*************************************************************************;
;* a = source bank				* Clobbers A,X,Y
;* x = source address
;* y = BBAD0|DMAP0
;*************************************************************************;
.global SetMDMA


;*************************************************************************;
;* If map_mode & 10h switch to hi-speed mode	* Clobbers A
;*************************************************************************;
.global MemSelect, mem_select


.endif
